let util = require("util");

module.exports = {
    /**@param {Creep} creep */
    run: function (creep) {
        if (creep.memory.working && creep.store[RESOURCE_ENERGY] == 0) {
            creep.memory.working = false;
            creep.say("harvest")
        }
        if (!creep.memory.working && creep.store.getFreeCapacity(RESOURCE_ENERGY) == 0) {
            creep.memory.working = true
            creep.say("builder")
        }
        if (creep.memory.working) {
            let target = creep.room.find(FIND_CONSTRUCTION_SITES);
            if (target.length > 0) {
                if (creep.build(target[0]) == ERR_NOT_IN_RANGE) {
                    creep.moveTo(target[0], {visualizePathStyle: {stroke: "#ffaa00"}});
                }
            } else {
                let targets = util.FindCapacity(creep);
                if (targets.length > 0) {
                    target.sort();
                    if (creep.transfer(targets[0], RESOURCE_ENERGY) == ERR_NOT_IN_RANGE) {
                        creep.moveTo(targets[0], {visualizePathStyle: {stroke: "#ffaa00"}});
                    }
                }
            }
        } else {
            creep.memory.working = false
            let sources = creep.room.find(FIND_SOURCES);
            if (creep.harvest(sources[0]) == ERR_NOT_IN_RANGE) {
                creep.moveTo(sources[0], {visualizePathStyle: {stroke: "#ffaa00"}});
            }
        }
    }
}