
let harvesterCount = 2;
let builderCount = 3;
let upgraderCount = 6;


/**@param {StructureSpawn} spawn */
var createDefaultHarvester = (spawn) => {
    let name = "Harvester" + Game.time;
    return spawn.spawnCreep([WORK, CARRY, MOVE], name, { memory: { role: "Harvester" } });
}
/**@param {StructureSpawn} spawn */
var createDefaultBuilder = (spawn) => {
    let name = "Builder" + Game.time;
    return spawn.spawnCreep([WORK, CARRY, MOVE], name, { memory: { role: "Builder" } });
}

/**@param {StructureSpawn} spawn */
var createDefaultUpgrader = (spawn) => {
    let name = "Upgrader" + Game.time;
    return spawn.spawnCreep([WORK, CARRY, MOVE], name, { memory: { role: "Upgrader" } });
}


module.exports = {
    /**@param {StructureSpawn} spawn*/
    run: function (spawn) {

        if (spawn.spawning) return;


        let harvesters = _.filter(Game.creeps,
            /**@param {Creep} creep*/
            (creep) => {
                return creep.memory.role == "Harvester";
            });
        let builders = _.filter(Game.creeps,
            /**@param {Creep} creep*/
            (creep) => {
                return creep.memory.role == "Builder";
            });
        let upgraders = _.filter(Game.creeps,
            /**@param {Creep} creep*/
            (creep) => {
                return creep.memory.role == "Upgrader";
            });
        if (harvesters.length < harvesterCount) {
            if (createDefaultHarvester(spawn) == 0) {
                console.log("Spawn Harvester")
            }
        }
        if (upgraders.length < upgraderCount) {
            if(createDefaultUpgrader(spawn) == 0){
                console.log("Spawn Upgrader")
            }
        }
        if (builders.length < builderCount) {
            if(createDefaultBuilder(spawn) == 0){
                console.log("Spawn Builder")
            }
        }

        if (spawn.spawning) {
            var spawningCreep = Game.creeps[spawn.spawning.name];
            spawn.room.visual.text(
                '🛠️' + spawningCreep.memory.role,
                spawn.pos.x + 1,
                spawn.pos.y,
                { align: 'left', opacity: 0.8 });
        }
    }
}